'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _Bacon = require('sigh-core');

exports['default'] = function (op) {
  var opts = arguments[1] === undefined ? {} : arguments[1];

  var karmaProc = op.procPool.prepare(function (opts) {
    var server = require('karma').server;
    var Promise = require('bluebird');
    var _ = require('lodash');
    var path = require('path');
    var log = require('sigh-core').log;

    _.assign(opts, { action: 'run', singleRun: true, autoWatch: true });
    _.defaults(opts, { configFile: path.resolve('karma.conf.js') });

    return function () {
      log('karma: run tests in process %s', process.pid);
      return new Promise(function (resolve) {
        server.start(opts, function (exitCode) {
          log('karma exit code: %s', exitCode);
          resolve(exitCode);
        });
      });
    };
  }, opts, { processLimit: 2 });

  return op.stream.flatMapLatest(function (events) {
    // TODO: log message if process was killed
    karmaProc.kill();

    return _Bacon.Bacon.fromPromise(karmaProc().then(function (exitCode) {
      return exitCode > 0 ? new _Bacon.Bacon.Error('karma: tests failed (' + exitCode + ')') : events;
    }));
  });
};

module.exports = exports['default'];
//# sourceMappingURL=index.js.map